package com.chinaitop.depot.intelligent.grainsituation.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TCcvalueExample {
    /**
     * t_ccvalue
     */
    protected String orderByClause;

    /**
     * t_ccvalue
     */
    protected boolean distinct;

    /**
     * t_ccvalue
     */
    protected List<Criteria> oredCriteria;

    public TCcvalueExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_ccvalue 2019-03-07
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVCcCodeIsNull() {
            addCriterion("v_cc_code is null");
            return (Criteria) this;
        }

        public Criteria andVCcCodeIsNotNull() {
            addCriterion("v_cc_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCcCodeEqualTo(String value) {
            addCriterion("v_cc_code =", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeNotEqualTo(String value) {
            addCriterion("v_cc_code <>", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeGreaterThan(String value) {
            addCriterion("v_cc_code >", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cc_code >=", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeLessThan(String value) {
            addCriterion("v_cc_code <", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cc_code <=", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeLike(String value) {
            addCriterion("v_cc_code like", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeNotLike(String value) {
            addCriterion("v_cc_code not like", value, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeIn(List<String> values) {
            addCriterion("v_cc_code in", values, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeNotIn(List<String> values) {
            addCriterion("v_cc_code not in", values, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeBetween(String value1, String value2) {
            addCriterion("v_cc_code between", value1, value2, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andVCcCodeNotBetween(String value1, String value2) {
            addCriterion("v_cc_code not between", value1, value2, "vCcCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeIsNull() {
            addCriterion("z_zd_code is null");
            return (Criteria) this;
        }

        public Criteria andZZdCodeIsNotNull() {
            addCriterion("z_zd_code is not null");
            return (Criteria) this;
        }

        public Criteria andZZdCodeEqualTo(String value) {
            addCriterion("z_zd_code =", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeNotEqualTo(String value) {
            addCriterion("z_zd_code <>", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeGreaterThan(String value) {
            addCriterion("z_zd_code >", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeGreaterThanOrEqualTo(String value) {
            addCriterion("z_zd_code >=", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeLessThan(String value) {
            addCriterion("z_zd_code <", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeLessThanOrEqualTo(String value) {
            addCriterion("z_zd_code <=", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeLike(String value) {
            addCriterion("z_zd_code like", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeNotLike(String value) {
            addCriterion("z_zd_code not like", value, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeIn(List<String> values) {
            addCriterion("z_zd_code in", values, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeNotIn(List<String> values) {
            addCriterion("z_zd_code not in", values, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeBetween(String value1, String value2) {
            addCriterion("z_zd_code between", value1, value2, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andZZdCodeNotBetween(String value1, String value2) {
            addCriterion("z_zd_code not between", value1, value2, "zZdCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNull() {
            addCriterion("v_cf_code is null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIsNotNull() {
            addCriterion("v_cf_code is not null");
            return (Criteria) this;
        }

        public Criteria andVCfCodeEqualTo(String value) {
            addCriterion("v_cf_code =", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotEqualTo(String value) {
            addCriterion("v_cf_code <>", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThan(String value) {
            addCriterion("v_cf_code >", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_cf_code >=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThan(String value) {
            addCriterion("v_cf_code <", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLessThanOrEqualTo(String value) {
            addCriterion("v_cf_code <=", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeLike(String value) {
            addCriterion("v_cf_code like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotLike(String value) {
            addCriterion("v_cf_code not like", value, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeIn(List<String> values) {
            addCriterion("v_cf_code in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotIn(List<String> values) {
            addCriterion("v_cf_code not in", values, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeBetween(String value1, String value2) {
            addCriterion("v_cf_code between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVCfCodeNotBetween(String value1, String value2) {
            addCriterion("v_cf_code not between", value1, value2, "vCfCode");
            return (Criteria) this;
        }

        public Criteria andVMaxIsNull() {
            addCriterion("v_max is null");
            return (Criteria) this;
        }

        public Criteria andVMaxIsNotNull() {
            addCriterion("v_max is not null");
            return (Criteria) this;
        }

        public Criteria andVMaxEqualTo(Integer value) {
            addCriterion("v_max =", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxNotEqualTo(Integer value) {
            addCriterion("v_max <>", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxGreaterThan(Integer value) {
            addCriterion("v_max >", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxGreaterThanOrEqualTo(Integer value) {
            addCriterion("v_max >=", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxLessThan(Integer value) {
            addCriterion("v_max <", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxLessThanOrEqualTo(Integer value) {
            addCriterion("v_max <=", value, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxIn(List<Integer> values) {
            addCriterion("v_max in", values, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxNotIn(List<Integer> values) {
            addCriterion("v_max not in", values, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxBetween(Integer value1, Integer value2) {
            addCriterion("v_max between", value1, value2, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMaxNotBetween(Integer value1, Integer value2) {
            addCriterion("v_max not between", value1, value2, "vMax");
            return (Criteria) this;
        }

        public Criteria andVMinIsNull() {
            addCriterion("v_min is null");
            return (Criteria) this;
        }

        public Criteria andVMinIsNotNull() {
            addCriterion("v_min is not null");
            return (Criteria) this;
        }

        public Criteria andVMinEqualTo(Integer value) {
            addCriterion("v_min =", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinNotEqualTo(Integer value) {
            addCriterion("v_min <>", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinGreaterThan(Integer value) {
            addCriterion("v_min >", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinGreaterThanOrEqualTo(Integer value) {
            addCriterion("v_min >=", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinLessThan(Integer value) {
            addCriterion("v_min <", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinLessThanOrEqualTo(Integer value) {
            addCriterion("v_min <=", value, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinIn(List<Integer> values) {
            addCriterion("v_min in", values, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinNotIn(List<Integer> values) {
            addCriterion("v_min not in", values, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinBetween(Integer value1, Integer value2) {
            addCriterion("v_min between", value1, value2, "vMin");
            return (Criteria) this;
        }

        public Criteria andVMinNotBetween(Integer value1, Integer value2) {
            addCriterion("v_min not between", value1, value2, "vMin");
            return (Criteria) this;
        }

        public Criteria andVAvgIsNull() {
            addCriterion("v_avg is null");
            return (Criteria) this;
        }

        public Criteria andVAvgIsNotNull() {
            addCriterion("v_avg is not null");
            return (Criteria) this;
        }

        public Criteria andVAvgEqualTo(BigDecimal value) {
            addCriterion("v_avg =", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgNotEqualTo(BigDecimal value) {
            addCriterion("v_avg <>", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgGreaterThan(BigDecimal value) {
            addCriterion("v_avg >", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("v_avg >=", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgLessThan(BigDecimal value) {
            addCriterion("v_avg <", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgLessThanOrEqualTo(BigDecimal value) {
            addCriterion("v_avg <=", value, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgIn(List<BigDecimal> values) {
            addCriterion("v_avg in", values, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgNotIn(List<BigDecimal> values) {
            addCriterion("v_avg not in", values, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_avg between", value1, value2, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVAvgNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("v_avg not between", value1, value2, "vAvg");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNull() {
            addCriterion("v_update_time is null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNotNull() {
            addCriterion("v_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeEqualTo(Date value) {
            addCriterion("v_update_time =", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotEqualTo(Date value) {
            addCriterion("v_update_time <>", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThan(Date value) {
            addCriterion("v_update_time >", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("v_update_time >=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThan(Date value) {
            addCriterion("v_update_time <", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("v_update_time <=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIn(List<Date> values) {
            addCriterion("v_update_time in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotIn(List<Date> values) {
            addCriterion("v_update_time not in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("v_update_time between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("v_update_time not between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }
    }

    /**
     * t_ccvalue
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_ccvalue 2019-03-07
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}